function ZhKeyboardService(eventEngine, rootScope){
	var self = this;
	var noRequestBeingMade = true;

	rootScope.$on('request.start', function() {
		noRequestBeingMade = false;
	});

	rootScope.$on('request.stop', function() {
		noRequestBeingMade = true;
	});

	this.bind = function(keys, callback, namespace) {
		namespace = namespace || 'default';

		var boundKeys = Util.parseToArray(keys).map(function(key) {
			var eventName = key + "Pressed";

			if(!eventEngine.hasEvent(eventName)){
				eventEngine.registerEvent(eventName, eventName);

				Mousetrap.bind(key, function(){
					self.mouseArguments = Array.prototype.slice.call(arguments);
					self[eventName]();
					return self.eventResult;
				});
			}

			var boundEventIndex = eventEngine.bindEvent(self, eventName, function(eventData) {
				//@toDo add '&& noRequestBeingMade' in if expression

				if (!mousetrapEventIsDefaultPrevented(eventData)) {
					self.eventResult = callback(self.mouseArguments[0], self.mouseArguments[1]);

				}
				return self.eventResult;
			});

			return {
				key: key,
				eventName: eventName,
				eventIndex: boundEventIndex
			};
		});

		return boundKeys;
	};

	function mousetrapEventIsDefaultPrevented(eventData) {
		return eventData.e.data === false;
	}

	this.unbind = function(keysToUnbind) {
		keysToUnbind = Util.parseToArray(keysToUnbind);

		var unboundKeysSuccess = keysToUnbind.map(function(key) {
			if (key.eventName) {
				return eventEngine.unbindEvent(self, key.eventName, key.eventIndex);
			} else {
				return eventEngine.unbindEvent(self, key+'Pressed', 0);
			}
		});

		return unboundKeysSuccess;
	};
}
